////////////////////////////////////////////////////////////////
// Gestion du clavier sous unix
//  tire de http://sxs.thexdershome.com/programming/kbhit.html
//
// Sylvain MARECHAL - sylvain.marechal1@libertysurf.fr
////////////////////////////////////////////////////////////////
#include "kbu.h"
#include <stdio.h>
#include <termios.h>
#include <unistd.h>   // for read()
#include <errno.h>

static struct termios initial_read_settings, new_read_settings;
static struct termios initial_write_settings, new_write_settings;

static int peek_character = -1;

#if 0
void main()
{
    init_keyboard();
    while(1)
    {
	int key = 0;
	while( kbhit() != 0 )
	{
	    key = getch();
	    printf( "key=%d\n", key );
	}
	if( key == 'q' ) 
	{
	    break;
	}
    }
    close_keyboard();
}
#endif

void init_keyboard()
{
    tcgetattr(0,&initial_read_settings);
    new_read_settings = initial_read_settings;
    new_read_settings.c_lflag &= ~ICANON;
    new_read_settings.c_lflag &= ~ECHO;
    new_read_settings.c_lflag &= ~ISIG;
    new_read_settings.c_cc[VMIN] = 1;
    new_read_settings.c_cc[VTIME] = 0;
    tcsetattr(0, TCSANOW, &new_read_settings);
/* Ne fonctionne pas ???
    if( tcgetattr(1,&initial_write_settings) < 0 )
    {
	fprintf( stderr, "errno=%d\n", errno );
    }
    new_write_settings = initial_write_settings;
    new_write_settings.c_lflag &= ~ICANON;
    new_write_settings.c_cc[VMIN] = 1;
    tcsetattr(1, TCSANOW, &new_write_settings);*/
}

void close_keyboard()
{
    tcsetattr(0, TCSANOW, &initial_read_settings);
//    tcsetattr(1, TCSANOW, &initial_write_settings);
}

int kbhit()
{
unsigned char ch;
int nread;

    if (peek_character != -1) return 1;
    new_read_settings.c_cc[VMIN]=0;
    tcsetattr(0, TCSANOW, &new_read_settings);
    nread = read(0,&ch,1);
    new_read_settings.c_cc[VMIN]=1;
    tcsetattr(0, TCSANOW, &new_read_settings);
    if(nread == 1) 
    {
        peek_character = ch;
        return 1;
    }
    return 0;
}

int readch()
{
char ch;

    if(peek_character != -1) 
    {
        ch = peek_character;
        peek_character = -1;
        return ch;
    }
    read(0,&ch,1);
    return ch;
}

