#ifndef PONGCORE_H
#define PONGCORE_H

#ifdef __cplusplus
extern "C" {
#endif

// Enum definissant le mode de jeu
typedef enum  {
    PONG_ALONE,
    PONG_CLIENT,
    PONG_SERVER
} PongMode;


// Enum definissant le status du jeu
typedef enum GameStatus 
{
    ENCOURS,
    GAGNE,
    PERDU
} GameStatus;


// Initialisation des donnees internes
// A appeler au debut
void InitPongGlobals( int xLargeur, int yHauteur, int xBatLen, int yBatLen, int xyBallLen );

// Set/Get des parametres du jeu
void PongSetSpeed( int xBallMove );
int PongGetSpeed();
int PongGetLargeur();
int PongGetHauteur();
int PongGetBatLen();
int PongGetXBallPos();
int PongGetYBallPos();
int PongGetLeftBatPos();
int PongGetRightBatPos();

// RAZ suit a nouvelle partie
void PongPlayReset();

// Deplacement de la raquette 
void PongLeftBatMove( int Decal );
void PongRightBatMove( int Decal );

// Deplacement de la balle
GameStatus PongBallMove();

// Utilisation en reseau : Dans ce cas
// c'est le serveur qui fait tout le boulot
void PongSetBallPos( int x, int y );
void PongSetLeftBatPos( int yPos);
void PongSetRightBatPos( int yPos);


#ifdef __cplusplus
}
#endif

#endif //PONGCORE_H

