////////////////////////////////////////////////////////////////
// Gestion du clavier
//
// Sylvain MARECHAL - sylvain.marechal1@libertysurf.fr
////////////////////////////////////////////////////////////////
#include <stdio.h>
#include "pongkevt.h"
#include "pongsock.h"

/////////////////////////////////////////////////////////////
// Gestion des touches du clavier
// -Renvoie la touche si elle a ete traitee
// -Renvoie 0 sinon
/////////////////////////////////////////////////////////////
int PongManageKeyboardEvent( int nKey, PongMode Mode )
{
    int ret = nKey;

    switch (nKey)
    {
    case FLECHE_HAUT:
	{
	    // Raquette en haut
	    switch(Mode)
	    {
#if SOCKET_SUPPORTED
	    case PONG_SERVER:
		{
		    PongLeftBatMove( -1 * PongGetBatLen()/2 );
		    PongSocketSendLeftBatPos();
		    break;
		}
	    case PONG_CLIENT:
		{
		    PongRightBatMove( -1 * PongGetBatLen()/2 );
		    PongSocketSendRightBatPos();
		    break;
		}
#endif //SOCKET_SUPPORTED
	    default:
		{
		    PongLeftBatMove( -1 * PongGetBatLen()/2 );
		    break;
		}
	    }
	    break;
	}		
    case FLECHE_BAS:
	{
	    // Raquette en bas
	    switch(Mode)
	    {
#if SOCKET_SUPPORTED
	    case PONG_SERVER:
		{
		    PongLeftBatMove( 1 * PongGetBatLen()/2 );
		    PongSocketSendLeftBatPos();
		    break;
		}
	    case PONG_CLIENT:
		{
		    PongRightBatMove( 1 * PongGetBatLen()/2 );
		    PongSocketSendRightBatPos();
		    break;
		}
#endif //SOCKET_SUPPORTED
	    default:
		{
		    PongLeftBatMove( 1 * PongGetBatLen()/2 );
		    break;
		}
	    }
	    break;
	}		
    case FLECHE_GAUCHE:
	{
	    // Ralentit
	    PongSetSpeed( PongGetSpeed() - 1 );
	    break;
	}		
    case FLECHE_DROITE:
	{
	    // Accelere
	    PongSetSpeed( PongGetSpeed() + 1 );
	    ret = 1;
	    break;
	}		
    case 'q':
    case 'Q':
	{
	    break;
	}
    default:
	{
	    ret = 0;
	    break;
	}
    } 
    return ret;
}

