////////////////////////////////////////////////////////////////
// Gestion des evenements de socket
//
// Sylvain MARECHAL - sylvain.marechal1@libertysurf.fr
////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "pongcore.h"
#include "pongsock.h"
#include "pongsevt.h"

/////////////////////////////////////////////////////////////
// Gestion des evenements de la socket non bloquante
//  Fait en sorte 
/////////////////////////////////////////////////////////////
int PongManageSocketEvent( SOCKET hSocket, int nEvent, unsigned int * pInMask, GameStatus * pGameStatus )
{
    int nRet = 0;
    
    
    // Donnee a lire ou connexion fermee    
    if( nEvent & FD_READ )
    {
	// Il y a des donnees a lire :
	// PongSocketEvtRecv lit les donnees et eventuellement
	// affiche la balle/la raquette a sa nouvelle position
	nRet = PongSocketEvtRecv(pGameStatus);
	if( nRet >= 0 )
	{
	    // On se prepare a relire de la donnee
	    *pInMask = *pInMask | FD_READ;
	}
	
    }

    // Connexion fermee
    if( nEvent & FD_CLOSE )
    {	    
	nRet = -1;
    }

    // La donnee peut etre ecrite
    if( nEvent & FD_WRITE )
    {
	// On peut ecrire les donnees : Cette fonction gere
	// les congestions reseaux, autant dire qu'elle ne sera
	// pas appelee souvent vu la taille de nos paquets
	nRet = PongSocketEvtReSend();
	if( nRet == 0 )
	{
	    // Il reste des donnees a ecrire
	    *pInMask = *pInMask | FD_WRITE;
	}
	else if( nRet > 0 )
	{
	    // Plus rien a faire
	    *pInMask = *pInMask &~ FD_WRITE;
	}
    }
    
    return nRet;
}

