#ifndef PONGSOCK_H
#define PONGSOCK_H

#include "socket.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef __TURBOC__
#include "socket.h"
#define SOCKET_SUPPORTED    1
#else
#define SOCKET_SUPPORTED    0
#endif

#if SOCKET_SUPPORTED
// Module base sur des sockets non bloquantes
// Fourniture de la socket
void PongSocketInitializeSocket( SOCKET hSocket );
void PongSocketDestroySocket();


// Envoie les dimensions de l'ecran pour le cas ou le 
// client et le serveur ont des dimensions differentes
int PongSocketSendDims();

// Envoie des positions de la raquette droite (client)
int PongSocketSendRightBatPos();

// Envoie position de la balle, de la raquette gauche, 
// et du status du jeu (gagne/perdu) (serveur)
int PongSocketSendBallPos();
int PongSocketSendStatusGame( GameStatus SenderStatus );
int PongSocketSendLeftBatPos();


// Reponse aux evenements reseau
// A executer sur reception de l'evenement write (client et serveur)
int PongSocketEvtReSend();
// A executer sur reception de l'evenement read (client et serveur)
int PongSocketEvtRecv( GameStatus *pStatus );
#endif //SOCKET_SUPPORTED


#ifdef __cplusplus
}
#endif

#endif	//PONGSOCK_H

