// Gestion du timer => Deplacement de la balle
//
// Sylvain MARECHAL - sylvain.marechal1@libertysurf.fr
////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "pongcore.h"
#include "pongsock.h"
#include "pongtevt.h"


/////////////////////////////////////////////////////////////
// Gestion des evenements timer utilise pour le deplacement
// de la balle
/////////////////////////////////////////////////////////////
GameStatus PongManageTimeoutEvent( PongMode Mode )
{
    GameStatus Status = ENCOURS;
    
    switch(Mode)
    {
#if SOCKET_SUPPORTED
    case PONG_CLIENT:
	{
	    // En fait, y'a rien a faire, tout est regit
	    // par les evenements sockets
	    break;
	}
	
    case PONG_SERVER:
	{
	    // Bouge la balle a sa nouvelle position
	    Status = PongBallMove();

	    // Envoie la position de la balle
	    PongSocketSendBallPos();

	    // Envoie le status si gagne/perdu
	    if( Status != ENCOURS )
	    {
		PongSocketSendStatusGame( Status );
	    }
	    break;
	}
#endif //SOCKET_SUPPORTED
    default:
	{
	    // Bouge la balle a sa nouvelle position
	    Status = PongBallMove();
	    
	    // Bouge la raquette droite pour simuler le mouvement
	    // de l'autre joueur
	    PongRightBatMove( (PongGetYBallPos() - PongGetRightBatPos() - PongGetBatLen()/2) );
	    
	    break;
	}
    }
    
    return Status;
}

