#ifndef SOCKETTTT_H
#define SOCKETTTT_H

#ifdef _WIN32

// Win32
#define SOCKET_SUPPORTED    1
#include <winsock2.h>
#define SOCKETERRNO	WSAGetLastError()
#define EWOULDBLOCK	WSAEWOULDBLOCK

#elif defined( __TURBOC__)

// Turbo C
#define SOCKET_SUPPORTED    0

#else

// Unix
#define SOCKET_SUPPORTED    1
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <string.h>
#include <errno.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <sys/time.h>
#include <netinet/tcp.h>
#include <fcntl.h>
#define SOCKETERRNO	errno
#define SOCKET		int
#define SOCKET_ERROR	-1
#define INVALID_SOCKET	-1
#define closesocket	close
#define FD_READ         0x01
#define FD_WRITE        0x02
#define FD_OOB          0x04
#define FD_ACCEPT       0x08
#define FD_CONNECT      0x10
#define FD_CLOSE        0x20
#endif

#ifdef __cplusplus
extern "C" {
#endif



#if SOCKET_SUPPORTED

void SocketError( SOCKET hSocket, int error );
SOCKET CreateListeningSocket( int nPort );
SOCKET CreateSocket();
struct sockaddr SocketFormatAdress( char * host, u_short port );
int ConnectSocket( SOCKET hSocket, char * pszHost, int nPort );
SOCKET AcceptSocket( SOCKET  hListeningSocket );
int SetBlockingModeSocket( SOCKET hSocket, int fBlocking );
int SocketRecv( SOCKET hSocket, char * pBuffer, int cbBuffer );
int SocketSend( SOCKET hSocket, char * pBuffer, int cbBuffer );

#endif //SOCKET_SUPPORTED



#ifdef __cplusplus
}
#endif


#endif //SOCKETTTT_H

