////////////////////////////////////////////////////////////////
// Programme principal Windows (WinMain())
// Fait avec les Wizards de VC 6.0 - Programme Win32
//
// Sylvain MARECHAL - sylvain.marechal1@libertysurf.fr
////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"
#include "pongcore.h"
#include "pongdp.h"
#include "pongsock.h"
#include "pongkevt.h"
#include "pongsevt.h"
#include "pongtevt.h"
#include "dlgabout.h"
#include "dlgconnect.h"
#include "dlgaccept.h"
#include "socket.h"

#define MAX_LOADSTRING	100
#define	WM_SOCKETEVENT	WM_USER+1


// Global Variables:
static HINSTANCE hInst;			    // current instance
static TCHAR szTitle[MAX_LOADSTRING];	    // The title bar text
static TCHAR szWindowClass[MAX_LOADSTRING]; // The title bar text

// Variables globales pour pong
static const int cs_xLargeur = 500;	    // Dimension x ecran
static const int cs_yHauteur = 400;	    // Dimension y ecran
static const int cs_xBatLen = 5;	    // Dimension x raquette
static const int cs_yBatLen = 40;	    // Dimension y raquette
static const int cs_xyBallLen = 5;	    // Diametre de la balle
static const int s_csBallMove = 10;	    // Vitesse
static HWND s_hWnd;			    // Fenetre principale
static HWND s_hWndBatLeft;		    // Raquette gauche
static HWND s_hWndBatRight;		    // Raquette droite
static HWND s_hWndBall;			    // Balle
static UINT s_uTimer;			    // Timer

static PongMode s_Mode = PONG_ALONE;	    // Mode client/serveur
static SOCKET s_hSocket;		    // Socket
static UINT s_nMask = 0;		    // Mask pour asyncselect()


// Foward declarations of functions included in this code module:
static ATOM MyRegisterClass(HINSTANCE hInstance);
static BOOL InitInstance(HINSTANCE, int);
static LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);


static int WndProcCreate(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
static int WndProcKeyDown(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
static int WndProcSocketEvent(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
static int WndProcTimer(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
static int WndProcCommand(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
static int WndProcDestroy(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);



//////////////////////////////////////////////////
//
//  FUNCTION: WinMain()
//
//  PURPOSE: Entry point.
//
//////////////////////////////////////////////////
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
    MSG msg;
    HACCEL hAccelTable;
    
    // Initialize global strings
    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
    LoadString(hInstance, IDC_WINPONG, szWindowClass, MAX_LOADSTRING);
    MyRegisterClass(hInstance);
    
    // Perform application initialization:
    if (!InitInstance (hInstance, nCmdShow)) 
    {
	return FALSE;
    }
    
    hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_WINPONG);
    
    // Main message loop:
    while (GetMessage(&msg, NULL, 0, 0)) 
    {
	if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
	{
	    TranslateMessage(&msg);
	    DispatchMessage(&msg);
	}
    }
    
    return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
    WNDCLASSEX wcex;
    
    wcex.cbSize = sizeof(WNDCLASSEX); 
    
    wcex.style		= CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc	= (WNDPROC)WndProc;
    wcex.cbClsExtra	= 0;
    wcex.cbWndExtra	= 0;
    wcex.hInstance	= hInstance;
    wcex.hIcon		= LoadIcon(hInstance, (LPCTSTR)IDI_WINPONG);
    wcex.hCursor	= LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
    wcex.lpszMenuName	= (LPCSTR)IDC_WINPONG;
    wcex.lpszClassName	= szWindowClass;
    wcex.hIconSm	= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);
    
    return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    HWND hWnd;
    
    hInst = hInstance; // Store instance handle in our global variable
    
    // On cree la fenetre de maniere qu'elle ne soit pas 
    // redimensionnable (WS_BORDER au lieu de WS_OVERLAPPEDWINDOW)
    hWnd = CreateWindow(szWindowClass, szTitle, //WS_OVERLAPPEDWINDOW,
	WS_BORDER | WS_SYSMENU,
	CW_USEDEFAULT, 0, 
	cs_xLargeur + cs_xyBallLen, 
	cs_yHauteur + cs_xyBallLen, 
	NULL, NULL, hInstance, NULL);
    
    if (!hWnd)
    {
	return FALSE;
    }
    
    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

    return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{    
    switch (message) 
    {
    case WM_CREATE:
	{
	    WndProcCreate(hWnd, message, wParam, lParam);
	    break;
	}
    case WM_KEYDOWN:
	{
	    WndProcKeyDown(hWnd, message, wParam, lParam);
	    break;
	}
    case WM_SOCKETEVENT:
	{
	    WndProcSocketEvent(hWnd, message, wParam, lParam);
	    break;
	}
    case WM_TIMER:
	{	 
	    WndProcTimer(hWnd, message, wParam, lParam);
	    break;
	}
    case WM_COMMAND:
	{
	    WndProcCommand(hWnd, message, wParam, lParam);
	    break;
	}
    case WM_DESTROY:
	{
	    WndProcDestroy(hWnd, message, wParam, lParam);
	    break;
	}
    default:
	{
	    return DefWindowProc(hWnd, message, wParam, lParam);
	}
    }
    return 0;
}

/////////////////////////////////////////////////////////
int WndProcCreate(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    RECT rect;
    
    // On memorise le handle de la fenetre dans une globale
    s_hWnd = hWnd;
    
    // On recupere l'aire de jeu
    GetClientRect ( hWnd, &rect);
    
    // Initialisation des parametres du jeu
    InitPongGlobals( rect.right, rect.bottom, cs_xBatLen, cs_yBatLen, cs_xyBallLen );
    
    // Rapidite
    PongSetSpeed( s_csBallMove );
    
    // Creation de la balle et des raquettes
    InitPongDisplay();
    
    return 0;
}

/////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////
int WndProcKeyDown(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int nKey;

    // On convertit le code en code pong
    switch (wParam)
    {
    case VK_UP:
	{
	    nKey = FLECHE_HAUT;
	    break;
	}		
    case VK_DOWN:
	{
	    nKey = FLECHE_BAS;
	    break;
	}		
    case VK_LEFT:
	{
	    nKey = FLECHE_GAUCHE;
	    break;
	}		
    case VK_RIGHT:
	{
	    nKey = FLECHE_DROITE;
	    break;
	}		
    } 

    // On passe a pong
    PongManageKeyboardEvent( nKey, s_Mode );
    return 0;
}


/////////////////////////////////////////////////////////
int WndProcSocketEvent(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    SOCKET hSocket = (SOCKET)wParam;
    int nError = WSAGETSELECTERROR(lParam);
    int nEvent = WSAGETSELECTEVENT(lParam);
    int nRet;
    GameStatus Status = ENCOURS;

    // Gestion des evenements de socket non bloquantes
    nRet = PongManageSocketEvent( hSocket, nEvent, &s_nMask, &Status );
    if( nRet == -1 )
    {
	// Deconnexion
	TCHAR szMessage[256];
	LoadString( hInst, IDS_CNXCLOSE, szMessage, sizeof(szMessage)/sizeof(TCHAR) - 1 );
	MessageBox( hWnd, szMessage, szTitle, MB_ICONEXCLAMATION );

	closesocket( s_hSocket );
	s_hSocket = INVALID_SOCKET;
	s_Mode = PONG_ALONE;
    }
    else if( nRet == -2 )
    {
	// Erreur (vraisemblablement une deconnexion)
	SocketError( s_hSocket, nError );
	closesocket( s_hSocket );
	s_hSocket = INVALID_SOCKET;
	s_Mode = PONG_ALONE;
    }
    else
    {
	// On sera rappele des qu'un (ou plusieurs) des evenements se produit
	if( WSAAsyncSelect( s_hSocket, s_hWnd, WM_SOCKETEVENT, s_nMask ) == SOCKET_ERROR )
	{
	    SocketError( s_hSocket, WSAGetLastError() );
	    return -1;
	}
    }

    // Status du jeu
    if( Status == PERDU || Status == GAGNE )
    {
	if( s_uTimer ) KillTimer( hWnd, s_uTimer );
	s_uTimer = 0;
	
	TCHAR szMessage[256];
	LoadString( hInst, (Status == PERDU ? IDS_PERDU : IDS_GAGNE), szMessage, sizeof(szMessage)/sizeof(TCHAR) - 1 );
	MessageBox( hWnd, szMessage, szTitle, MB_ICONEXCLAMATION );
	return -1;
    }
    
    return 0;
}

/////////////////////////////////////////////////////////
int WndProcTimer(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    GameStatus Status;
    
    // Deplacement de la balle en mode alone/server
    Status = PongManageTimeoutEvent( s_Mode );
    
    // Message + nettoyage si partie finie
    if( Status != ENCOURS )
    {
	KillTimer( hWnd, s_uTimer );
	s_uTimer = 0;
	
	TCHAR szMessage[256];
	LoadString( hInst, (Status == PERDU ? IDS_PERDU : IDS_GAGNE), szMessage, sizeof(szMessage)/sizeof(TCHAR) - 1 );
	MessageBox( hWnd, szMessage, szTitle, MB_ICONEXCLAMATION );
    }
    return 0;
}

/////////////////////////////////////////////////////////
int WndProcCommand(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int wmId, wmEvent;

    wmId    = LOWORD(wParam); 
    wmEvent = HIWORD(wParam); 
    
    switch (wmId)
    {
    case IDM_ABOUT:
	{
	    // Boite de dialogue About
	    DlgAbout(hInst, hWnd);
	    break;
	}
    case IDM_ACCEPT:
	{
	    // Boite de dialogue du serveur
	    if( s_hSocket != INVALID_SOCKET ) closesocket( s_hSocket );
	    s_hSocket = DlgAccept( hInst, hWnd );
	    if( s_hSocket != INVALID_SOCKET )
	    {
		// Mode serveur
		s_Mode = PONG_SERVER;

		// On ecoute le reseau
		PongSocketInitializeSocket( s_hSocket );
		s_nMask = FD_READ | FD_CLOSE;
		WndProcSocketEvent( hWnd, 0, 0, 0 );		

		// On envoie les dimensions de notre ecran
		PongSocketSendDims();
	    }
	    else
	    {
		s_Mode = PONG_ALONE;
	    }
	    break;
	}
    case IDM_CONNECT:
	{
	    // Boite de dialogue du client
	    if( s_hSocket != INVALID_SOCKET ) closesocket( s_hSocket );
	    s_hSocket = DlgConnect( hInst, hWnd );
	    if( s_hSocket != INVALID_SOCKET )
	    {
		// Mode client
		s_Mode = PONG_CLIENT;

		// On ecoute le reseau
		PongSocketInitializeSocket( s_hSocket );
		s_nMask = FD_READ | FD_CLOSE;
		WndProcSocketEvent( hWnd, 0, 0, 0 );
		
		// On envoie les dimensions de notre ecran
		PongSocketSendDims();
	    }
	    else
	    {
		s_Mode = PONG_ALONE;
	    }
	    break;
	}
    case IDM_EXIT:
	{
	    // Fin
	    DestroyWindow(hWnd);
	    break;
	}
    case IDM_JEU:
	{
	    // Initialisation d'une nouvelle partie
	    switch(s_Mode )
	    {
	    case PONG_ALONE:
		{
		    PongPlayReset();
		    PongLeftBatMove( 0 );
		    PongRightBatMove( 0 );
		    
		    // Creation du timer
		    if( s_uTimer ) KillTimer( hWnd, s_uTimer );
		    s_uTimer = SetTimer( hWnd, 1, 100, NULL );
		    break;
		}
	    case PONG_CLIENT:
		{
		    // C'est le serveur qui commande!
		    break;
		}
	    case PONG_SERVER:
		{
		    PongPlayReset();
		    PongLeftBatMove( 0 );

		    // Creation du timer
		    if( s_uTimer ) KillTimer( hWnd, s_uTimer );
		    s_uTimer = SetTimer( hWnd, 1, 100, NULL );
		    break;
		}
	    }
	    break;
	}
    default:
	{
	    return DefWindowProc(hWnd, message, wParam, lParam);
	}
    }
    return 0;
}

/////////////////////////////////////////////////////////
int WndProcDestroy(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    if( s_uTimer) KillTimer( hWnd, s_uTimer );
    s_uTimer = 0;
    if( s_hSocket ) closesocket( s_hSocket );
    PongSocketDestroySocket();
    PostQuitMessage(0);
    return 0;
}




////////////////////////////////////////////////
// InitPongDisplay()
////////////////////////////////////////////////
void InitPongDisplay()
{
    HWND hWnd = s_hWnd;

    // Creation des raquettes et de la balle
    s_hWndBatLeft = CreateWindow( "STATIC", "", WS_CHILD | SS_BLACKRECT, 1, (cs_yHauteur - cs_yBatLen)/2, cs_xBatLen, cs_yBatLen, hWnd, NULL, hInst, NULL );
    ShowWindow( s_hWndBatLeft, SW_SHOW );
    PongLeftBatMove( 0 );
    s_hWndBatRight = CreateWindow( "STATIC", "", WS_CHILD | SS_BLACKRECT, 1, (cs_yHauteur - cs_yBatLen)/2, cs_xBatLen, cs_yBatLen, hWnd, NULL, hInst, NULL );
    ShowWindow( s_hWndBatRight, SW_SHOW );
    PongRightBatMove( 0 );
    s_hWndBall = CreateWindow( "STATIC", "", WS_CHILD | SS_BLACKRECT, 200, cs_yBatLen/2, cs_xyBallLen, cs_xyBallLen, hWnd, NULL, hInst, NULL );
    ShowWindow( s_hWndBall, SW_SHOW );
}


////////////////////////////////////////////////
// PongStatusDisplay()
////////////////////////////////////////////////
void PongStatusDisplay( char * pszStatus )
{
    // Pas besoin de barre de status ici
    // On pourrait creer un controle texte
    // et ecrire dedans.
}


////////////////////////////////////////////////
// PongStatusGetString()
////////////////////////////////////////////////
int PongStatusGetString( char * ,char * , int )
{
    // Inutile, tout comme PongStatusDisplay()
    return 0;
}


////////////////////////////////////////////////
// PongBatDisplay()
// Bouge la raquette
////////////////////////////////////////////////
void PongBatDisplay( int /*yBatPrec*/, int xBatPos, int yBatPos, int xBatLen, int yBatLen, int fLeft )
{
    HWND hWndBat = ( fLeft ? s_hWndBatLeft : s_hWndBatRight );
    MoveWindow( hWndBat, xBatPos, yBatPos, xBatLen, yBatLen, TRUE );
}

////////////////////////////////////////////////
// PongBallDisplay()
// Bouge la balle
////////////////////////////////////////////////
void PongBallDisplay( int xPrec, int yPrec, int xBallPos, int yBallPos, int xyBallLen )
{
    MoveWindow( s_hWndBall, xBallPos, yBallPos, xyBallLen, xyBallLen, TRUE );
}